gcc_release (upload_files): Put diff files into a "diffs" subdirectory
[gcc.git] / maintainer-scripts / gcc_release
1 #! /bin/sh
2
3 ########################################################################
4 #
5 # File: gcc_release
6 # Author: Jeffrey Law, Bernd Schmidt, Mark Mitchell
7 # Date: 2001-05-25
8 #
9 # Contents:
10 # Script to create a GCC release.
11 #
12 # Copyright (c) 2001, 2002 Free Software Foundation.
13 #
14 # This file is part of GCC.
15 #
16 # GCC is free software; you can redistribute it and/or modify
17 # it under the terms of the GNU General Public License as published by
18 # the Free Software Foundation; either version 2, or (at your option)
19 # any later version.
20 #
21 # GCC is distributed in the hope that it will be useful,
22 # but WITHOUT ANY WARRANTY; without even the implied warranty of
23 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
24 # GNU General Public License for more details.
25 #
26 # You should have received a copy of the GNU General Public License
27 # along with GCC; see the file COPYING. If not, write to
28 # the Free Software Foundation, 59 Temple Place - Suite 330,
29 # Boston, MA 02111-1307, USA.
30 #
31 ########################################################################
32
33 ########################################################################
34 # Notes
35 ########################################################################
36
37 # Here is an example usage of this script, to create a GCC 3.0.2
38 # prerelease:
39 #
40 # gcc_release -r 3.0.2
41 #
42 # This script will automatically use the head of the release branch
43 # to generate the release.
44
45 ########################################################################
46 # Functions
47 ########################################################################
48
49 # Issue the error message given by $1 and exit with a non-zero
50 # exit code.
51
52 error() {
53 echo "gcc_release: error: $1"
54 exit 1
55 }
56
57 # Issue the informational message given by $1.
58
59 inform() {
60 echo "gcc_release: $1"
61 }
62
63 # Issue a usage message explaining how to use this script.
64
65 usage() {
66 cat <<EOF
67 gcc_release -r release [further options]
68 gcc_release -s [further options]
69
70 Options:
71
72 -r release Version of the form X.Y or X.Y.Z.
73 -s Create a snapshot, not a real release.
74
75 -d destination Local working directory where we will build the release
76 (default=${HOME}).
77 -f Create a final release (and update ChangeLogs,...).
78 -l Indicate that we are running on gcc.gnu.org.
79 -p previous-tarball Location of a previous tarball (to generate diff files).
80 -t tag Tag to mark the release in CVS.
81 -u username Username for upload operations.
82 EOF
83 exit 1
84 }
85
86 # Change to the directory given by $1.
87
88 changedir() {
89 cd $1 || \
90 error "Could not change directory to $1"
91 }
92
93 # Each of the arguments is a directory name, relative to the top
94 # of the source tree. Return another name for that directory, relative
95 # to the working directory.
96
97 adjust_dirs() {
98 for x in $@; do
99 echo `basename ${SOURCE_DIRECTORY}`/$x
100 done
101 }
102
103 # Build the source tree that will be the basis for the release
104 # in ${WORKING_DIRECTORY}/gcc-${RELEASE}.
105
106 build_sources() {
107 # If the WORKING_DIRECTORY already exists, do not risk destroying it.
108 if [ -r ${WORKING_DIRECTORY} ]; then
109 error "\`${WORKING_DIRECTORY}' already exists"
110 fi
111 # Create the WORKING_DIRECTORY.
112 mkdir "${WORKING_DIRECTORY}" \
113 || error "Could not create \`${WORKING_DIRECTORY}'"
114 changedir "${WORKING_DIRECTORY}"
115
116 # If this is a final release, make sure that the ChangeLogs
117 # and version strings are updated.
118 if [ ${FINAL} -ne 0 ]; then
119 inform "Updating ChangeLogs and version files"
120
121 ${CVS} co -d "`basename ${SOURCE_DIRECTORY}`" \
122 -r ${BRANCH} gcc || \
123 error "Could not check out release sources"
124 for x in `find ${SOURCE_DIRECTORY} -name ChangeLog`; do
125 cat - ${x} > ${x}.new <<EOF
126 ${LONG_DATE} Release Manager
127
128 * GCC ${RELEASE} Released.
129
130 EOF
131 mv ${x}.new ${x} || \
132 error "Could not update ${x}"
133 (changedir `dirname ${x}` && \
134 ${CVS} ci -m 'Mark ChangeLog' `basename ${x}`) || \
135 error "Could not commit ${x}"
136 done
137
138 # Update `gcc/version.c'.
139 for x in gcc/version.c; do
140 y=`basename ${x}`
141 (changedir `dirname ${SOURCE_DIRECTORY}/${x}` && \
142 sed -e 's|= \".*\"|= \"'${RELEASE}'\"|g' < ${y} > ${y}.new && \
143 mv ${y}.new ${y} && \
144 ${CVS} ci -m 'Update version' ${y}) || \
145 error "Could not update ${x}"
146 done
147
148 # Make sure we tag the sources for a final release.
149 TAG="gcc_`echo ${RELEASE} | tr . _`_release"
150
151 rm -rf ${SOURCE_DIRECTORY}
152 fi
153
154 # Tag the sources.
155 if [ -n "${TAG}" ]; then
156 inform "Tagging release sources"
157 ${CVS} rtag -r ${BRANCH} -F ${TAG} gcc || \
158 error "Could not tag release sources"
159 BRANCH=$TAG
160 fi
161
162 # Export the current sources.
163 inform "Retrieving release sources"
164 ${CVS} \
165 export -d "`basename ${SOURCE_DIRECTORY}`" \
166 -r ${BRANCH} gcc || \
167 error "Could not retrieve release sources"
168
169 # Run gcc_update on them to set up the timestamps nicely.
170 changedir "gcc-${RELEASE}"
171 contrib/gcc_update --touch
172
173 # Obtain some documentation files from the wwwdocs module.
174 inform "Retrieving HTML documentation"
175 changedir "${WORKING_DIRECTORY}"
176 for x in bugs gnats faq; do
177 (${CVS} export -r HEAD wwwdocs/htdocs/${x}.html && \
178 cp ${WORKING_DIRECTORY}/wwwdocs/htdocs/${x}.html \
179 ${SOURCE_DIRECTORY}) || \
180 error "Could not retrieve ${x}.html"
181 done
182
183 inform "Generating plain-text documentation from HTML"
184 changedir "${SOURCE_DIRECTORY}"
185 for file in *.html; do
186 newfile=`echo $file | sed -e 's/.html//' | tr "[:lower:]" "[:upper:]"`
187 (${ENV} TERM=vt100 lynx -dump $file \
188 | sed -e "s#file://localhost`/bin/pwd`\(.*\)#http://gcc.gnu.org\1#g" \
189 > $newfile) || \
190 error "Could not regenerate documentation"
191 done
192
193 # For a prerelease or real release, we need to generate additional
194 # files not present in CVS.
195 changedir "${SOURCE_DIRECTORY}"
196 if [ $SNAPSHOT -ne 1 ]; then
197 # Generate the documentation.
198 inform "Building install docs"
199 SOURCEDIR=${SOURCE_DIRECTORY}/gcc/doc
200 DESTDIR=${SOURCE_DIRECTORY}/INSTALL
201 export SOURCEDIR
202 export DESTDIR
203 ${SOURCE_DIRECTORY}/gcc/doc/install.texi2html
204
205 # Regenerate the NEWS file.
206 contrib/gennews > gcc/NEWS || \
207 error "Could not regenerate NEWS files"
208
209 # Now, we must build the compiler in order to create any generated
210 # files that are supposed to go in the source directory. This is
211 # also a good sanity check to make sure that the release builds
212 # on at least one platform.
213 inform "Building compiler"
214 OBJECT_DIRECTORY=../objdir
215 contrib/gcc_build -d ${SOURCE_DIRECTORY} -o ${OBJECT_DIRECTORY} build || \
216 error "Could not rebuild GCC"
217
218 # Regenerate the Fotran NEWS and BUGS files.
219 (cd ${OBJECT_DIRECTORY}/gcc && make f77.rebuilt) || \
220 error "Could not regenerate Fortran NEWS and BUGS files"
221 fi
222
223 # Move message catalogs to source directory.
224 mv ../objdir/gcc/po/*.gmo gcc/po/
225
226 # Create a `.brik' file to use for checking the validity of the
227 # release.
228 changedir "${SOURCE_DIRECTORY}"
229 BRIK_FILE=`mktemp /tmp/gcc_release.XXXXXXX`
230 ((find . -type f | sort > $BRIK_FILE) && \
231 brik -Gb -f ${BRIK_FILE} > .brik && \
232 rm ${BRIK_FILE}) || \
233 error "Could not compute brik checksum"
234 }
235
236 # Buid a single tarfile. The first argument is the name of the name
237 # of the tarfile to build, without any suffixes. They will be added
238 # automatically. The rest of the arguments are the files or
239 # directories to include.
240
241 build_tarfile() {
242 # Get the name of the destination tar file.
243 TARFILE="$1.tar.gz"
244 shift
245
246 # Build the tar file itself.
247 (${TAR} cf - "$@" | ${GZIP} > ${TARFILE}) || \
248 error "Could not build tarfile"
249 FILE_LIST="${FILE_LIST} ${TARFILE}"
250 }
251
252 # Build the various tar files for the release.
253
254 build_tarfiles() {
255 inform "Building tarfiles"
256
257 changedir "${WORKING_DIRECTORY}"
258
259 # The GNU Coding Standards specify that all files should
260 # world readable.
261 chmod -R a+r ${SOURCE_DIRECTORY}
262 # And that all directories have mode 777.
263 find ${SOURCE_DIRECTORY} -type d -exec chmod 777 {} \;
264
265 # Build one huge tarfile for the entire distribution.
266 build_tarfile gcc-${RELEASE} `basename ${SOURCE_DIRECTORY}`
267
268 # Now, build one for each of the languages.
269 build_tarfile gcc-ada-${RELEASE} ${ADA_DIRS}
270 build_tarfile gcc-g++-${RELEASE} ${CPLUSPLUS_DIRS}
271 build_tarfile gcc-g77-${RELEASE} ${FORTRAN_DIRS}
272 build_tarfile gcc-java-${RELEASE} ${JAVA_DIRS}
273 build_tarfile gcc-objc-${RELEASE} ${OBJECTIVEC_DIRS}
274 build_tarfile gcc-testsuite-${RELEASE} ${TESTSUITE_DIRS}
275
276 # The core is everything else.
277 EXCLUDES=""
278 for x in ${ADA_DIRS} ${CPLUSPLUS_DIRS} ${FORTRAN_DIRS} \
279 ${JAVA_DIRS} ${OBJECTIVEC_DIRS} ${TESTSUITE_DIRS}; do
280 EXCLUDES="${EXCLUDES} --exclude $x"
281 done
282 build_tarfile gcc-core-${RELEASE} ${EXCLUDES} \
283 `basename ${SOURCE_DIRECTORY}`
284 }
285
286 # Build .bz2 files.
287 build_bzip2() {
288 for f in ${FILE_LIST}; do
289 bzfile=${f%.gz}.bz2
290 (zcat $f | ${BZIP2} > ${bzfile}) || error "Could not create ${bzfile}"
291 done
292 }
293
294 # Build diffs against an old release.
295 build_diffs() {
296 old_dir=${1%/*}
297 old_file=${1##*/}
298 old_vers=${old_file%.tar.gz}
299 old_vers=${old_vers#gcc-}
300 inform "Building diffs against version $old_vers"
301 for f in gcc gcc-ada gcc-g++ gcc-g77 gcc-java gcc-objc gcc-testsuite gcc-core; do
302 old_tar=${old_dir}/${f}-${old_vers}.tar.gz
303 new_tar=${WORKING_DIRECTORY}/${f}-${RELEASE}.tar.gz
304 if [ -e $old_tar ] && [ -e $new_tar ]; then
305 build_diff $old_tar gcc-${old_vers} $new_tar gcc-${RELEASE} \
306 ${f}-${old_vers}-${RELEASE}.diff.gz
307 fi
308 done
309 }
310
311 # Build an individual diff.
312 build_diff() {
313 changedir "${WORKING_DIRECTORY}"
314 tmpdir=gccdiff.$$
315 mkdir $tmpdir || error "Could not create directory $tmpdir"
316 changedir $tmpdir
317 tar xfz $1 || error "Could not unpack $1 for diffs"
318 tar xfz $3 || error "Could not unpack $3 for diffs"
319 ${DIFF} $2 $4 > ../${5%.gz}
320 if [ $? -eq 2 ]; then
321 error "Trouble making diffs from $1 to $3"
322 fi
323 ${GZIP} ../${5%.gz} || error "Could not gzip ../${5%.gz}"
324 changedir ..
325 rm -rf $tmpdir
326 FILE_LIST="${FILE_LIST} $5"
327 }
328
329 # Upload the files to the FTP server.
330
331 upload_files() {
332 inform "Uploading files"
333
334 changedir "${WORKING_DIRECTORY}"
335
336 # Make sure the directory exists on the server.
337 if [ $LOCAL -eq 0 ]; then
338 ${SSH} -l ${GCC_USERNAME} ${GCC_HOSTNAME} \
339 mkdir -p "${FTP_PATH}/diffs"
340 UPLOAD_PATH="${GCC_USERNAME}@${GCC_HOSTNAME}:${FTP_PATH}"
341 else
342 mkdir -p "${FTP_PATH}/diffs" \
343 || error "Could not create \`${FTP_PATH}'"
344 UPLOAD_PATH=${FTP_PATH}
345 fi
346
347 # Then copy files to their respective (sub)directories.
348 for x in gcc*.gz gcc*.bz2; do
349 if [ -e ${x} ]; then
350 # Make sure the file will be readable on the server.
351 chmod a+r ${x}
352 # Copy it.
353 case ${x} in
354 *.diff.*)
355 SUBDIR="diffs/";
356 ;;
357 *)
358 SUBDIR="";
359 esac
360 ${SCP} ${x} ${UPLOAD_PATH}/${SUBDIR} \
361 || error "Could not upload ${x}"
362 fi
363 done
364 }
365
366 ########################################################################
367 # Initialization
368 ########################################################################
369
370 # Today's date.
371 DATE=`date "+%Y%m%d"`
372 LONG_DATE=`date "+%Y-%m-%d"`
373
374 # The CVS server containing the GCC repository.
375 CVS_SERVER="gcc.gnu.org"
376 # The path to the repository on that server.
377 CVS_REPOSITORY="/cvs/gcc"
378 # The CVS protocol to use.
379 CVS_PROTOCOL="ext"
380 # The username to use when connecting to the server.
381 CVS_USERNAME="${USER}"
382
383 # The machine to which files will be uploaded.
384 GCC_HOSTNAME="gcc.gnu.org"
385 # The name of the account on the machine to which files are uploaded.
386 GCC_USERNAME="gccadmin"
387 # The directory in which the files will be placed.
388 FTP_PATH="~ftp/pub/gcc"
389
390 # The major number for the release. For release `3.0.2' this would be
391 # `3'
392 RELEASE_MAJOR=""
393 # The minor number for the release. For release `3.0.2' this would be
394 # `0'.
395 RELEASE_MINOR=""
396 # The revision number for the release. For release `3.0.2' this would
397 # be `2'.
398 RELEASE_REVISION=""
399 # The complete name of the release.
400 RELEASE=""
401
402 # The name of the branch from which the release should be made.
403 BRANCH=""
404
405 # The tag to apply to the sources used for the release.
406 TAG=""
407
408 # The old tarballs from which to generate diffs.
409 OLD_TARS=""
410
411 # The directory that will be used to construct the release. The
412 # release itself will be placed in a subdirectory of this diretory.
413 DESTINATION=${HOME}
414 # The subdirectory.
415 WORKING_DIRECTORY=""
416 # The directory that will contain the GCC sources.
417 SOURCE_DIRECTORY=""
418
419 # The directories that should be part of the various language-specific
420 # tar files. These are all relative to the top of the source tree.
421 ADA_DIRS="gcc/ada"
422 CPLUSPLUS_DIRS="gcc/cp libstdc++-v3"
423 FORTRAN_DIRS="gcc/f libf2c"
424 JAVA_DIRS="gcc/java libjava libffi fastjar zlib boehm-gc"
425 OBJECTIVEC_DIRS="gcc/objc libobjc"
426 TESTSUITE_DIRS="gcc/testsuite"
427
428 # Non-zero if this is the final release, rather than a prerelease.
429 FINAL=0
430
431 # Non-zero if we are building a snapshot, and don't build gcc or
432 # include generated files.
433 SNAPSHOT=0
434
435 # Non-zero if we are running locally on gcc.gnu.org, and use local CVS
436 # and copy directly to the FTP directory.
437 LOCAL=0
438
439 # Major operation modes.
440 MODE_BZIP2=0
441 MODE_DIFFS=0
442 MODE_SOURCES=0
443 MODE_TARFILES=0
444 MODE_UPLOAD=0
445
446 # .gz files generated to create .bz2 files from.
447 FILE_LIST=""
448
449 # Programs we use.
450
451 BZIP2="${BZIP2:-bzip2}"
452 CVS="${CVS:-cvs -f -Q -z9}"
453 DIFF="${DIFF:-diff -Nrc3pad}"
454 ENV="${ENV:-env}"
455 GZIP="${GZIP:-gzip --best}"
456 SCP="${SCP:-scp -p}"
457 SSH="${SSH:-ssh}"
458 TAR="${TAR:-tar}"
459
460 ########################################################################
461 # Command Line Processing
462 ########################################################################
463
464 # Parse the options.
465 while getopts "d:fr:u:t:p:sl" ARG; do
466 case $ARG in
467 d) DESTINATION="${OPTARG}";;
468 r) RELEASE="${OPTARG}";;
469 t) TAG="${OPTARG}";;
470 u) CVS_USERNAME="${OPTARG}";;
471 f) FINAL=1;;
472 s) SNAPSHOT=1;;
473 l) LOCAL=1
474 SCP=cp
475 FTP_PATH=~ftp/pub/gcc
476 PATH=~:/usr/local/bin:$PATH;;
477 p) OLD_TARS="${OLD_TARS} ${OPTARG}"
478 if [ -d ${OPTARG} ]; then
479 error "-p argument must name a tarball"
480 fi;;
481 \?) usage;;
482 esac
483 done
484 shift `expr ${OPTIND} - 1`
485
486 # Perform consistency checking.
487 if [ ${LOCAL} -eq 0 ] && [ -z ${CVS_USERNAME} ]; then
488 error "No username specified"
489 fi
490
491 if [ ! -d ${DESTINATION} ]; then
492 error "\`${DESTINATION}' is not a directory"
493 fi
494
495 if [ $SNAPSHOT -eq 0 ]; then
496 if [ -z ${RELEASE} ]; then
497 error "No release number specified"
498 fi
499
500 # Compute the major and minor release numbers.
501 RELEASE_MAJOR=`echo $RELEASE | awk --assign FS=. '{ print $1; }'`
502 RELEASE_MINOR=`echo $RELEASE | awk --assign FS=. '{ print $2; }'`
503 RELEASE_REVISION=`echo $RELEASE | awk --assign FS=. '{ print $3; }'`
504
505 if [ -z "${RELEASE_MAJOR}" ] || [ -z "${RELEASE_MINOR}" ]; then
506 error "Release number \`${RELEASE}' is invalid"
507 fi
508
509 # Compute the full name of the release.
510 if [ -z "${RELEASE_REVISION}" ]; then
511 RELEASE="${RELEASE_MAJOR}.${RELEASE_MINOR}"
512 else
513 RELEASE="${RELEASE_MAJOR}.${RELEASE_MINOR}.${RELEASE_REVISION}"
514 fi
515
516 # Compute the name of the branch, which is based solely on the major
517 # and minor release numbers.
518 BRANCH="gcc-${RELEASE_MAJOR}_${RELEASE_MINOR}-branch"
519
520 # If this is not a final release, set various parameters acordingly.
521 if [ ${FINAL} -ne 1 ]; then
522 RELEASE="${RELEASE}-${DATE}"
523 FTP_PATH="${FTP_PATH}/snapshots/"
524 else
525 FTP_PATH="${FTP_PATH}/releases/gcc-${RELEASE}/"
526 fi
527 else
528 RELEASE=$DATE
529 # For now snapshots come from the 3.3 branch.
530 BRANCH=gcc-3_3-branch
531 FTP_PATH="${FTP_PATH}/snapshots/${LONG_DATE}"
532 TAG=gcc_ss_${DATE}
533
534 # Building locally on gcc.gnu.org, we know what the last snapshot date
535 # was.
536 if [ $LOCAL -ne 0 ]; then
537 LAST_DATE=`cat ~/.snapshot_date`
538 LAST_LONG_DATE=`date --date=$LAST_DATE +%Y-%m-%d`
539 LAST_DIR=~ftp/pub/gcc/snapshots/${LAST_LONG_DATE}
540 OLD_TARS=${LAST_DIR}/gcc-${LAST_DATE}.tar.gz
541 fi
542 fi
543
544 # Compute the name of the WORKING_DIRECTORY and the SOURCE_DIRECTORY.
545 WORKING_DIRECTORY="${DESTINATION}/gcc-${RELEASE}"
546 SOURCE_DIRECTORY="${WORKING_DIRECTORY}/gcc-${RELEASE}"
547
548 # Recompute the names of all the language-specific directories,
549 # relative to the WORKING_DIRECTORY.
550 ADA_DIRS=`adjust_dirs ${ADA_DIRS}`
551 CPLUSPLUS_DIRS=`adjust_dirs ${CPLUSPLUS_DIRS}`
552 FORTRAN_DIRS=`adjust_dirs ${FORTRAN_DIRS}`
553 JAVA_DIRS=`adjust_dirs ${JAVA_DIRS}`
554 OBJECTIVEC_DIRS=`adjust_dirs ${OBJECTIVEC_DIRS}`
555 TESTSUITE_DIRS=`adjust_dirs ${TESTSUITE_DIRS}`
556
557 # Set up CVSROOT.
558 if [ $LOCAL -eq 0 ]; then
559 CVSROOT=":${CVS_PROTOCOL}:${CVS_USERNAME}@"
560 CVSROOT="${CVSROOT}${CVS_SERVER}:${CVS_REPOSITORY}"
561 else
562 CVSROOT="${CVS_REPOSITORY}"
563 fi
564 export CVSROOT
565
566 ########################################################################
567 # Main Program
568 ########################################################################
569
570 # Set the timezone to UTC
571 TZ="UTC0"
572 export TZ
573
574 # Handle the major modes.
575 while [ $# -ne 0 ]; do
576 case $1 in
577 bzip2) MODE_BZIP2=1;;
578 diffs) MODE_DIFFS=1;;
579 sources) MODE_SOURCES=1;;
580 tarfiles) MODE_TARFILES=1;;
581 upload) MODE_UPLOAD=1;;
582 all) MODE_SOURCES=1; MODE_TARFILES=1; MODE_DIFFS=1; MODE_BZIP2=1; MODE_UPLOAD=1;;
583 *) error "Unknown mode $1";;
584 esac
585 shift
586 done
587
588 # Build the source directory.
589
590 if [ $MODE_SOURCES -ne 0 ]; then
591 build_sources
592 fi
593
594 # Build the tar files.
595
596 if [ $MODE_TARFILES -ne 0 ]; then
597 build_tarfiles
598 fi
599
600 # Build diffs
601
602 if [ $MODE_DIFFS -ne 0 ]; then
603 # Possibly build diffs.
604 if [ -n "$OLD_TARS" ]; then
605 for old_tar in $OLD_TARS; do
606 build_diffs $old_tar
607 done
608 fi
609 fi
610
611 # Build bzip2 files
612 if [ $MODE_BZIP2 -ne 0 ]; then
613 build_bzip2
614 fi
615
616 # Upload them to the FTP server.
617
618 if [ $MODE_UPLOAD -ne 0 ]; then
619 upload_files
620
621 # For snapshots, make some further updates.
622 if [ $SNAPSHOT -ne 0 ] && [ $LOCAL -ne 0 ]; then
623 # Update links on the FTP server.
624 TEXT_DATE=`date --date=$DATE +%B\ %d,\ %Y`
625 cd ~ftp/pub/gcc/snapshots
626 sed -e "s%@DATE@%$DATE%g" -e "s%@LAST_DATE@%$LAST_DATE%g" \
627 -e "s%@LONG_DATE@%$LONG_DATE%g" \
628 -e "s%@TEXT_DATE@%$TEXT_DATE%g" < ~/scripts/snapshot-README > $$
629 mv $$ README
630 sed -e "s%@DATE@%$DATE%g" -e "s%@LAST_DATE@%$LAST_DATE%g" \
631 -e "s%@LONG_DATE@%$LONG_DATE%g" \
632 -e "s%@TEXT_DATE@%$TEXT_DATE%g" < ~/scripts/snapshot-index.html > $$
633 mv $$ index.html
634
635 touch LATEST-IS-$LONG_DATE
636 rm -f LATEST-IS-$LAST_LONG_DATE
637
638 # Update snapshot date file.
639 changedir ~
640 echo $DATE >.snapshot_date
641
642 # Update gcc_latest_snapshot tag.
643 ${CVS} rtag -d gcc_latest_snapshot gcc
644 ${CVS} rtag -rgcc_ss_${DATE} gcc_latest_snapshot gcc
645
646 # Announce the snapshot.
647 export QMAILHOST=gcc.gnu.org
648 mail -s "gcc-ss-$DATE is now available" gcc@gcc.gnu.org < ~ftp/pub/gcc/snapshots/README
649
650 # Remove working directory
651 rm -rf ${WORKING_DIRECTORY}
652 fi
653 fi